org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class ProgramTest.TestProgram

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.map.ProgramTest.TestProgram

- All Implemented Interfaces:
    Cloneable, VertexProgram
  Enclosing class:
    ProgramTest

      public static class ProgramTest.TestProgram
      extends Object
      implements VertexProgram

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Builder, VertexProgram.Features`

  - ### Field Summary

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TestProgram()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ProgramTest.TestProgram` | `clone()` When multiple workers on a single machine need VertexProgram instances, it is possible to use clone.
    `void` | `execute(Vertex vertex, Messenger messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `Set<MemoryComputeKey>` | `getMemoryComputeKeys()` The `Memory` keys that will be used during the computation.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `Set<VertexComputeKey>` | `getVertexComputeKeys()` The `Element` properties that will be mutated during the computation.
    `void` | `loadState(Graph graph, Configuration configuration)` When it is necessary to load the state of the VertexProgram, this method is called.
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `void` | `storeState(Configuration configuration)` When it is necessary to store the state of the VertexProgram, this method is called.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.
    `void` | `workerIterationEnd(Memory memory)` This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.
    `void` | `workerIterationStart(Memory memory)` This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getFeatures, getMapReducers, getMessageCombiner, getTraverserRequirements`

- - ### Constructor Detail

    - #### TestProgram

          public TestProgram()

  - ### Method Detail

    - #### loadState

          public void loadState(Graph graph,
                                Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to load the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is loaded is simply the instance state, not any processed data.
      Specified by:
        `loadState` in interface `VertexProgram`
      Parameters:
        `graph` - the graph that the VertexProgram will run against
        `configuration` - the configuration to load the state of the VertexProgram from.

    - #### storeState

          public void storeState(Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to store the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is stored is simply the instance/configuration state, not any processed data. The default implementation provided simply stores the VertexProgram class name for reflective reconstruction. It is typically a good idea to VertexProgram.super.storeState().
      Specified by:
        `storeState` in interface `VertexProgram`
      Parameters:
        `configuration` - the configuration to store the state of the VertexProgram in.

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Specified by:
        `setup` in interface `VertexProgram`
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### execute

          public void execute(Vertex vertex,
                              Messenger messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Specified by:
        `execute` in interface `VertexProgram`
      Parameters:
        `vertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Specified by:
        `terminate` in interface `VertexProgram`
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### workerIterationStart

          public void workerIterationStart(Memory memory)

      Description copied from interface: `VertexProgram`
      This method is called at the start of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Specified by:
        `workerIterationStart` in interface `VertexProgram`
      Parameters:
        `memory` - The memory at the start of the iteration.

    - #### workerIterationEnd

          public void workerIterationEnd(Memory memory)

      Description copied from interface: `VertexProgram`
      This method is called at the end of each iteration of each "computational chunk." The set of vertices in the graph are typically not processed with full parallelism. The vertex set is split into subsets and a worker is assigned to call the `VertexProgram.execute(org.apache.tinkerpop.gremlin.structure.Vertex, org.apache.tinkerpop.gremlin.process.computer.Messenger<M>, org.apache.tinkerpop.gremlin.process.computer.Memory)` method. The default implementation is a no-op.
      Specified by:
        `workerIterationEnd` in interface `VertexProgram`
      Parameters:
        `memory` - The memory at the end of the iteration.

    - #### getVertexComputeKeys

          public Set<VertexComputeKey> getVertexComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Element` properties that will be mutated during the computation. All properties in the graph are readable, but only the keys specified here are writable. The default is an empty set.
      Specified by:
        `getVertexComputeKeys` in interface `VertexProgram`
      Returns:
        the set of element keys that will be mutated during the vertex program's execution

    - #### getMemoryComputeKeys

          public Set<MemoryComputeKey> getMemoryComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Memory` keys that will be used during the computation. These are the only keys that can be read or written throughout the life of the `GraphComputer`. The default is an empty set.
      Specified by:
        `getMemoryComputeKeys` in interface `VertexProgram`
      Returns:
        the set of memory keys that will be read/written

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Specified by:
        `getMessageScopes` in interface `VertexProgram`
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### clone

          public ProgramTest.TestProgram clone()

      Description copied from interface: `VertexProgram`
      When multiple workers on a single machine need VertexProgram instances, it is possible to use clone. This will provide a speedier way of generating instances, over the `VertexProgram.storeState(Configuration)` and `VertexProgram.loadState(org.apache.tinkerpop.gremlin.structure.Graph, Configuration)` model. The default implementation simply returns the object as it assumes that the VertexProgram instance is a stateless singleton.
      Specified by:
        `clone` in interface `VertexProgram`
      Overrides:
        `clone` in class `Object`
      Returns:
        A clone of the VertexProgram object

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

      Specified by:
        `getPreferredResultGraph` in interface `VertexProgram`

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

      Specified by:
        `getPreferredPersist` in interface `VertexProgram`

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.